<?php
/*
Plugin Name: Linrodeth Election
Plugin URI: https://blog.tremlas.com/wordpress-plugins/get-elected-plugin-details/
Description: Adds a shortcode that inserts the get elected! game
Version: 3.226.0
Author: David Vines
Author URI: http://tremlas.com
License:  Creative Commons License
*/
/* © Copyright 2014, 2021 David Vines

   Creative Commons License

   This work is licensed under a Creative Commons Attribution-NonCommercial-ShareAlike 4.0 International License.
*/

include_once 'common.php';

/**
 * Shortcode to add the version of the plugin
 */
function djv_getElected_getElectedVersion_shortcode() {
	return 'Linrodeth Election Version 3.226.0';
}
add_shortcode( 'getelectedVersion', 'djv_getElected_getElectedVersion_shortcode' );

/**
 * Add the "Get Elected game". Only one per page is supported.
 */

// Now for a shortcode that can be used to get links and/or tables for the characters
function djv_getElected_shortcode( $attr, $content = null ) {
	$plugin_url = plugin_dir_url(__FILE__);
	wp_enqueue_script('djv_getelected_toggle', $plugin_url.'js/toggle.js', array(), '3.226.0' );
	wp_enqueue_script('djv_getelected_rot', $plugin_url.'js/rot/rot.min.js', array(), '3.226.0' );
	wp_enqueue_script('djv_getelected_game', $plugin_url.'js/getelected/game.js', array(), '3.226.0' );
	wp_enqueue_script('djv_getelected_address', $plugin_url.'js/getelected/address.js', array(), '3.226.0' );
	wp_enqueue_script('djv_getelected_screens', $plugin_url.'js/getelected/screens.js', array(), '3.226.0' );
	wp_enqueue_script('djv_getelected_names', $plugin_url.'js/getelected/names.js', array(), '3.226.0' );
	wp_enqueue_script('djv_getelected_elector', $plugin_url.'js/getelected/elector.js', array(), '3.226.0' );
	wp_enqueue_script('djv_getelected_reasons', $plugin_url.'js/getelected/reasons.js', array(), '3.226.0' );
	wp_enqueue_script('djv_getelected_first', $plugin_url.'js/getelected/firstlines.js', array(), '3.226.0' );
	wp_enqueue_script('djv_getelected_faction', $plugin_url.'js/getelected/faction.js', array(), '3.226.0' );
	wp_enqueue_script('djv_getelected_chronicle', $plugin_url.'js/getelected/chronicle.js', array(), '3.226.0' );

	wp_enqueue_style('djv_getelectedstyle', $plugin_url.'css/getelected.css');

	$file = plugin_dir_path(__FILE__);
	$filecontent = file_get_contents($file.'/html/getelected.html');
	$filecontent = str_replace("oldgate_small.png", $plugin_url.'html/oldgate_small.png', $filecontent);

	return $filecontent;
}

add_shortcode( 'getelected', 'djv_getElected_shortcode' );

/* --------------------- Functions for updating plugins ------------------------------ */
function djv_getElected_pre_set_site_transient_update_plugins( $transient ) {
 $id = 'LinrodethElection/getElectedPlugin.php';
 $name = 'Linrodeth Election';
 $slug = 'LinrodethElection';
 return djv_plugin_pre_set_site_transient( $transient, $id, $name, $slug, '3.226.0' );
}
add_filter( 'pre_set_site_transient_update_plugins', 'djv_getElected_pre_set_site_transient_update_plugins' );

function djv_getElected_plugin_info( $result, $action, $args ) {
	$name = 'Linrodeth Election';
	$slug = 'LinrodethElection';
	if ( 'plugin_information' !== $action ) {
		return $result;
	}
	if ( $slug !== $args->slug) {
		return $result;
	}
	return djv_plugin_get_remote_update_info( $name, $slug );
}
add_filter( 'plugins_api', 'djv_getElected_plugin_info', 10, 3 );

?>