//
// © 2016 David Vines
//
// Creative Commons License
//
// This work is licensed under a Creative Commons Attribution-NonCommercial-ShareAlike 4.0 International License.
//
/* globals ROT, Game, console, Faction */
var ReserveSherrifs = [{index:undefined, name:"Paston Courtney"},
                       {index:undefined, name:"Miranda Andrews"},
                       {index:undefined, name:"Alison Shefford"},
                       {index:undefined, name:"Nicholas Bowden"},
                       {index:undefined, name:"Jenny Davy"}];
Faction.forEach(function(f){
    ReserveSherrifs.push({index: undefined, name: f.getLeader()});
});
ReserveSherrifs = ReserveSherrifs.randomize();

var Chronicle = {
    events: [{text: "Be it known that by Royal Decree that the most ungodly and riotous sport of football is BANNED, on pain of imprisonment.", remove: true},
             {text: "D'alenson, the notorious cat-burglar, escaped from Marshgate Prison which had held him for over two years. Several days later an archer was found stabbed to death on the northern wall overlooking the marshes. The events may not be connected, but certain nervous Goldsmiths have seen fit to set a rooftop guard.",
              act: function() { 
                  Game._factors.crime *= 2;
                  Game._electorate.forEach(function(v) {
                      if (v.getGuild() === "Goldsmiths") {
                          v.addWorry("crime");
                      }
                  });
              },
              remove: true},
             {text: "The ward of Marshgate is this month afflicted with a sweating fever which has already claimed many lives. The Torian priests are warning people to avoid the area unless their business is urgent, however they have not yet decided to apply to the Council for quarantine permission.",
              act: function() { Game._factors.plague *= 2; } },
             {text: "The <i>Corn Crisis</i> is worsening and the price of bread is rising to new highs.",
              act: function() { Game._factors.famine *= 2; } },
             {text: "Civil unrest has been reported in many parts of the city after rumours of severe price-fixing by the Vintner's Guild.",
              act: function() { Game._factors.famine *= 1.5; Game._factors.crime *= 2; } },
             {text: "Residents of Castle Bard are warned to be on their guard after a sudden increase in robberies around the college.",
              act: function() { Game._factors.crime *= 2; } },
             {text: "An outbreak of nausea and sweating in the ward of Portsoken is being investigated by the Torian Temple.",
              act: function() { Game._factors.plague *= 2; } },
             {text: "The Great Fire which destroyed most of the wards of Cripplegate, Avignon and Faringdon has now died down. The smouldering ruins of the top of Faringdon hill still dominate the skyline and much of the City's thoughts.",
              act: function() { Game._factors.fire *= 4; },
              remove:true},
             {text: "The city of Nyskilde has fallen to an unexpected attack by the the Noord. This shock news arrived with the few remaining ships to escape the the raid and reports are still confused.",
              act: function() { Game._factors.invasion *= 2; },
              remove: true},
             {text: "Citizens have been warned to be on their guard following a sharp increase in the number of muggings in the ward of Ishtan.",
              act: function() { Game._factors.crime *= 2; } },
             {text: "Cripplegate Ward has been suffering from an outbreak of illness that has left its cesspits overflowing.",
              act: function() { Game._factors.plague *= 2; } },
             {text: "Sherrif %s reports the capture of Colin the Keys, the notorious felon.",
              act: function() { Game._factors.crime /= 2; },
              remove: true},
             {text: "Citizens will be relieved to hear that the lethal pestilence in East Hill has died down and appears to be spreading no further.",
              act: function() { Game._factors.plague /= 2; } },
             {text: "A major fire in Bergon Street recently was contained after many nearby houses were pulled down.",
              act: function() { Game._factors.fire *= 2; } },
             {text: "News from the south is that Prince Edward anticipates renewed barbarian raiding in the coming months.",
              act: function() { Game._factors.invasion *= 1.5; } },
             {text: "<i>The Chronicle</i> would like to send condolences to the Morgan family whose son Peven died violently while returning from evening watch duty.",
              act: function() {Game._factors.crime *=2; },
              remove: true},
             {text: "Last weekend the Citadel offically announced that the Queen was <i>gravely ill</i>. The Queen has apparently been ill for some time.",
              act: function() {
                  Chronicle.events.push({text: "Sir William Valois has been executed on the charges of HIGH TREASON. Sir William's slow poisoning of the Queen was discovered in the nick of time by Sir Raif Fitz-Payne",
                      remove: true});
              },
              remove:true},
             {text: "The proprieters of <i>The Bull and Bucket</i> annouce that they are closing for repairs until further notice.",
              remove: true},
             {text: "Prince Edward has (at great cost) taken the barbarian stronghold of Cair Taned. This victory is a major relief to the merchants of this city",
              act: function() { Game._factors.invasion /= 2; },
              remove: true},
             {text: "Rumours reaching the Chronicle this month suggest that trouble is brewing amongst the many factions in the floating market. Citizens are warned to take greater than usual care if in the vicinity of this market.",
              act: function() { Game._factors.crime *= 1.5; } },
             {text: "The Chronicle is pleased to annouce its newest roving reporter: Chinon Starsinger. Chinon hopes to be reporting from beneath the tables of all the best pubs and clubs around town",
              act: function() {
                  Chronicle.events.push({text:"Chinon Starsinger is extolling <i>The Sea-Serpent</i> as this month's place to eat out."},
                                        {text:"Chinon Starsinger, our redoubtable reporter, was pleased to accept an invitation to the newly restored <i>Bullion Inn</i>."},
                                        {text:"Chinon Starsinger reports that the new <i>Uncle Marcus</i> brew, which has been produced by the <i>Empty Barrel</i> in Welland, is the best he's tasted in years."},
                                        {text:"Chinon Starsinger reporys that the '<i>Empty Barrel</i> in Welland is now broaching several new barrels of <i>Reggy's Best</i>."});
              },
              remove: true},
             {text: "A demented soothsayer appeared in Bilgestreet Market to forecast floods, storms and vile death; a not inaccurate prediction you might think. The crazed crone disappeared under a hail of herring."},
             {text: "Citizens of Arpent and Faringdon are warned that some prankster is lifting random items of laundry from back yards.",
              act: function() {Game._factors.crime *= 1.1;}},
             {text: "Highly reliable sources at the Citadel have confirmed the rumour that the 5th Infantry are due to leave for the Southern Border.",
              act: function() {Game._factors.invasion /= 1.25; }},
             {text: "Violence flared in the long-suffering ward of Dowgate this month as vagabonds from the floating market mounted yet another raid on local citizenry.",
              act: function() {Game._factors.crime *= 1.5; }},
             {text: "A small fire which broke out in Ishtan ward overnight was quickly contained by local residents and the appalling weather.",
              act: function() {Game._factors.fire *= 1.25; }},
             {text: "The ward of Marshgate was rocked by an explosion late last week. The home of one Talus Snapdragon (Master Apothecary) was almost totally destroyed when 'one of his preparations got a little out of hand.'",
              act: function() {Game._factors.fire *= 1.25; }},
             {text: "Vanessa St Lawrence would be pleased to receive any information leading to the recovery of a small bronze casket stolen last week. No intrinstic but great sentimental value. A small reward is offered.",
              act: function() {Game._factors.crime *= 1.25; },
              remove: true},
             {text: "The Knight-Marshall has been forced to send troops to restore order in nearby villages after fighting broke out around the granaries. Some villages have already run out of food and the Wellkeeper reports severe shortages throughout the countryside.",
              act: function() {Game._factors.famine *= 2; }},
             {text: "The Lord of the City, %l, in response to popular demand, is encouraging local watches to 'crack down on crime' Anyone noticing suspicious activity is asked to report it to their local Alderman.",
              act: function() {Game._factors.crime /= 2; }},
             {text: "As many citizens will be aware, Linrodeth's bridge has been closed for emergency repairs.",
              act: function() {Chronicle.events.push({text: "As many citizens will be aware, Linrodeth's bridge has been closed, yet again, for emergency repairs."});},
              remove: true},
             {text: "It is with deep regret that the Chronicle announces the death of Baldwin Underwood. The alderman's body was discovered hanging from one of the supports of the Linrodeth Bridge by members of the local watch.",
              act: function() {Game._factors.crime *= 1.5;},
              remove: true},
             {text: "The next harvest is looking to be an excellent one following the recent run of good growing weather.",
              act: function() {Game._factors.famine /= 2; }},
             {text: "This has been a bumper month for snoopers and gossipmongers with investigation after investigation whispering its way through the Witanmoot. Now far be it for the Chroniclers to spoil any councillor's fun, but shouldn't they really be spending our hard-earned taxes on solving the city's problems?"}
            ],
    write: function(news,year,month) {
        var format = {
            lord: function() { return Game._lordOfCity; },
            sherrif: function() { return Game._sherrifs.random().name; }
        };
        String.format.map.l = "lord";
        String.format.map.s = "sherrif";
        if (ROT.RNG.getPercentage() <= Chronicle.events.length/2 ) {
            var e = Chronicle.events.random();
            news.push(e.text.format(format));
            if (e.act) {
                e.act();
            }
            if (e.remove) {
                Chronicle.events.splice(Chronicle.events.indexOf(e),1);
            }
        }
        
        // Now the sherrif election (if applicable)
        if (month === "Heliora") {
            var incoming;
            var recompute = function(flag) {
                Game._electorate[Game._aldermanIndex].setEligible(flag);
                Game._electorate.forEach(function(v){
                    var oldp = v.getFirstPreference();
                    v.computeFirstPreference(Game._electorate);
                    if (oldp !== v.getFirstPreference()) {
                        console.log(v.getName()+" has changed their (potential) vote from "+Game._electorate[oldp].getName()+" to "+Game._electorate[v.getFirstPreference()].getName());
                    }
                });
            };
            if (Game._sherrifs.length === 2 && ROT.RNG.getPercentage() <= 67) {
                // Change of Sherrif
                var outgoing = ROT.RNG.getUniformInt(0,1);
                if (ROT.RNG.getUniformInt(0,11) < Game._sherrifVotes) {
                    incoming = {index: Game._aldermanIndex, name: Game._electorate[Game._aldermanIndex].getName()};
                    recompute(false);
                } else {
                    incoming = ReserveSherrifs.shift();
                }
                news.push("In a shock result from the midsummer sherrif elections, "+Game._sherrifs[outgoing].name+" has been replaced by "+incoming.name+". "+Game._sherrifs[1-outgoing].name+" remains in post.");
                if (Game._sherrifs[outgoing].index) {
                    recompute(true);
                } else {
                    ReserveSherrifs.push(Game._sherrifs[outgoing]);
                    ReserveSherrifs = ReserveSherrifs.randomize();
                }
                Game._sherrifs[outgoing] = incoming;
            } else if (Game._sherrifs.length === 1) {
                if (ROT.RNG.getUniformInt(0,11) < Game._sherrifVotes) {
                    incoming = {index: Game._aldermanIndex, name: Game._electorate[Game._aldermanIndex].getName()};
                    recompute(false);
                } else {
                    incoming = ReserveSherrifs.shift();
                }
                news.push(incoming.name+" has been elected to fill the vacancy caused by the election of "+Game._lordOfCity+" to Lord of the City earlier this year. "+incoming.name+" joins Sherrif "+Game._sherrifs[0].name+".");
                Game._sherrifs[1] = incoming;
            } else {
                news.push("At the midsummer sherrif elections, there was no change to the Sherrifs and "+Game._sherrifs[0].name+" and "+Game._sherrifs[1].name+" remain in post.");
            }
        }
        
        // And the lordship election
        if (month === "Galemir") {
            if (ROT.RNG.getPercentage() <= 60) {
                var newlord = ROT.RNG.getUniformInt(0,1);
                Game._lordOfCity = Game._sherrifs[newlord].name;
                Game._sherrifs.splice(newlord,1);
                news.push("After heavy campaigning by all factions, a new Lord of the City has been elected. Please welcome "+Game._lordOfCity+" to this august post.");
            } else {
                news.push("At the recent Lordship elections "+Game._lordOfCity+" was reelected to the post.");
            }
        }
    }
};