//
// © 2016 David Vines
//
// Creative Commons License
//
// This work is licensed under a Creative Commons Attribution-NonCommercial-ShareAlike 4.0 International License.
//
/* globals ROT, Game, console */
function Faction(leader,hir,focus,chronicle,support,reject,duelist) {
    this._leader = leader;
    this._hir = hir;
    this._focus = focus;
    this._totalScore = 0;
    this._chronicle = chronicle;
    this._duelist = duelist;
    this._support = support;
    this._reject = reject;
}

Faction.prototype = {
    rateLine: function(line) {
            var oldScore = this._totalScore;
            this._totalScore += line.getRelevance(this._focus) - 5;
            if (this._totalScore !== oldScore) {
                console.log(this._leader+" has reacted and their totalscore is now "+this._totalScore);
            }
    },
    makeNews: function() {
        var other = this;
        while (other === this) {
            other = Faction._factions.random();
        }
        var temple = ROT.RNG.getWeightedValue({"Hahn":3,"Torus":6,"Daleth":2,"Espreyanna":1,"Brynette":1});
        var noteworthy = false;
        if (ROT.RNG.getPercentage() <= 3) {
            Game._news.push(this._leader+" has accused "+other._leader+" of misconduct.");
            noteworthy = true;
        } else if (ROT.RNG.getPercentage() <= 3) {
            Game._news.push(this._leader+" has proposed in the Witanmoot a vote of thanks to the temple of "+temple+".");
            noteworthy = true;
        } else if (ROT.RNG.getPercentage() <= 3 && this.duelist) {
            Game._news.push(this._leader+" has challenged "+other._leader+" to a duel.");
            noteworthy = true;
        } else if (ROT.RNG.getPercentage() <= 3) {
            Game._news.push(this._leader+" has fallen seriously ill and has been forced to visit the Torian Temple.");
            noteworthy = true;
        } else if (ROT.RNG.getPercentage() <= 3) {
            Game._news.push(this._leader+" has taken to hiring bodyguards.");
            noteworthy = true;
        } else if (ROT.RNG.getPercentage() <= 3) {
            Game._news.push(this._chronicle);
            noteworthy = true;
        }
        var factionFocus = this._focus;
        if (noteworthy && Game._councillor) {
            var count = 0;
            var nameofchanged;
            var lastchanged;
            var msgtext;
            if (this._totalScore > 33) {
                Game._electorate.forEach(function(v){
                    if (v.getName() !== "YOU") {
                        lastchanged = v.improvePreference(Game._electorate,v.getFocusScore(factionFocus,Game._factors)/20);
                        if (lastchanged) {
                            count++;
                            nameofchanged = v.getName();
                        }
                    }
                });
                msgtext = "<b>Private Message from "+this._leader+":</b> Thank you for supporting "+this._support+". I've spoken with ";
                if (count === 0) {
                   msgtext += "my followers to encourage them to vote for you";
                } else if (count === 1) {
                    msgtext += nameofchanged+" and they told me that they are now planning to vote for you in the next election";
                    Game._estimatedVote++;
                } else if (count < 3) {
                    msgtext += "my followers and a few of them are now planning to vote for you";
                    Game._estimatedVote += 2;
                } else if (count < 7) {
                    msgtext += "my followers and some of them are now planning to vote for you";
                    Game._estimatedVote += 3;
                } else if (count < 11) {
                    msgtext += "my followers and a quite a few of them are now planning to vote for you";
                    Game._estimatedVote += 7;
                } else if (count < 16) {
                    msgtext += "my followers and many of them are now planning to vote for you";
                    Game._estimatedVote += 11;
                } else if (count < 30) {
                    msgtext += "my followers and most of them are now planning to vote for you";
                    Game._estimatedVote += 16;
                } else {
                    msgtext += "my followers and almost all of them are now planning to vote for you";
                    Game._estimatedVote += 30;
                }
                msgtext +=  " and here's ten shillings for your election fund.";
                Game._news.push(msgtext);
                Game._money += 120;
                this._totalScore -= 30; // Almost all of the score consumed by the attaboy
            } else if (this._totalScore < -24) {
                Game._electorate.forEach(function(v){
                    if (v.getName() !== "YOU") {
                        lastchanged = v.diminishPreference(Game._electorate,v.getFocusScore(factionFocus,Game._factors)/20);
                        if (lastchanged) {
                            count++;
                            nameofchanged = v.getName();
                        }
                    }
                });
                msgtext = "<b>Private Message from "+this._leader+":</b> I'm worried that you "+this._reject+". I've spoken with ";
                if (count === 0) {
                    msgtext += "my followers to persuade them that it's not worth voting for you";
                } else if (count === 1) {
                     Game._estimatedVote--;
                     msgtext += nameofchanged+" and they told me that they are now planning not to vote for you in the next election";
                } else if (count < 3) {
                     msgtext += "my followers and a few of them are now planning not to vote for you";
                     Game._estimatedVote -= 2;
                } else if (count < 7) {
                     msgtext += "my followers and some of them are now planning not to vote for you";
                     Game._estimatedVote -= 3;
                } else if (count < 11) {
                     msgtext += "my followers and a quite a few of them are now planning not to vote for you";
                     Game._estimatedVote -= 7;
                } else if (count < 16) {
                     msgtext += "my followers and many of them are now planning not to vote for you";
                     Game._estimatedVote -= 11;
                } else if (count < 30) {
                     msgtext += "my followers and most of them are now planning not to vote for you";
                     Game._estimatedVote -= 16;
                } else {
                     msgtext += "my followers and almost all of them are now planning not to vote for you";
                     Game._estimatedVote -= 30;
                }
                msgtext +=  ".";
                if (Game._estimatedVote < 1) {
                    Game._estimatedVote = 1;
                }
                Game._news.push(msgtext);
                this._totalScore = 0; // The anger is mitigated by the revenge
            }
        }
    },
    smear: function(inc) {
        this._totalScore -= inc;
        console.log(this._leader+" reacts to smears, totalScore now "+this._totalScore);
    },
    promote: function(inc) {
        this._totalScore += inc;
        console.log(this._leader+" reacts to promotion efforts, totalScore now "+this._totalScore);
    },
    getLeader: function() {
        return this._leader;
    }
};

Faction._factions = [];
Faction.addFaction = function(name,focus,news,support,reject,duelist) {
    Faction._factions.push(new Faction(name,focus,news,support,reject,duelist));
};
Faction.forEach = function(f) {
    Faction._factions.forEach(f);
};
Faction.random = function() {
    return Faction._factions.random();
};
Faction.recruitAlderman = function(alderman) {
    if (ROT.RNG.getPercentage() <= Faction._factions.length) {
        var oldf = alderman.getFaction();
        var newf = Faction._factions.random();
        if (newf !== oldf) {
            Game._news.push("Alderman "+alderman.getName()+" has left the "+oldf.getLeader()+" faction and joined the faction led by "+newf.getLeader()+". "+alderman.getName()+" said 'I believe I can do more for Oldgate under the leadership of "+newf.getLeader()+" and look forward to working with "+newf._hir+" in the Witanmoot.'");
            alderman.setFaction(newf);
        }
    }
};
Faction.addFaction("Malcolm Mowbray","him","crime","Master Vinter Malcolm Mowbray wishes to announce the discovery of several forged documents, which purport to come from him.","my fight againt crime","seem to be supporting the undesirable elements in this City.",false);
Faction.addFaction("Armundus Septer","him","money","Master Scrivener Armundus Septer held a dignified soiree attended by many notable citizens.","the guilds","seem to be working against the guildmembers and hard working folk of this city",false);
Faction.addFaction("Adam Avery","him","fire","Councillor Adam Avery has been working to alleviate overcrowing and homelessness in wards recently affected by fire.","my work to prevent overcrowding and the risk of fire","seem to be ignoring the very real risk of fire",true);
Faction.addFaction("Matthew Dixon","him","invasion","Master Carpenter Matthew Dixon has announced that he is to fund horsemanship training for the Witanmoot Guard.","my efforts to defend Linrodeth","seem to be a traitor",true);
Faction.addFaction("Alan Monteray","him","plague","Councillor Alan Monteray has been seen sneaking around the city wells and pouring the water into perfume bottles.","my efforts to stop disease and plague ravishing our fair City","seem to be ignoring the advice of the Torian Temple",true);
Faction.addFaction("Aralan Derwent","her","famine","Alderman Aralan Derwent has announced the conclusion of a deal to secure supplies of grain for the rest of the year.","my efforts to ensure this city is fed","seem to be supporting the price gouging cornmongers",true);
Faction.addFaction("Larken Drumm","him","fun","Another elegantly dressed councillor was Larken Drumm who has been seen surrounded by several young ladies at the recent Civc Ball.","my latest party","don't seem to be having enough fun",true);
Faction.addFaction("Beatrice Perignon","her","formal","Roland and Julia Perignon have been looking at houses and land in Levestone. The incentive behind this business appears to be one Beatrice Perignon who has mentioned that 'we wish to become a grandmother'.","good manners and etiquette","seem to be most uncouth",false);
